/*
	ppps_int_heap.c
	[TvCu] int^̃q[v
	
	author:  K.Y (Programming Place Plus)
	
	version  1.0.3   '2019/10/2
	           EWebTCg C99Ki֑ΉƂɍ킹āAR[hCB
			     RgX^CƁAϐ錾ʒuςB
                 bool^gB
             
             1.0.2   '2018/4/3
	           Eup_heap֐̖̎ʂCB
	             ɁAɓB܂ő召֌W̔rJԂĂB
	
	         1.0.1   '2013/2/9
	           Edown_root֐AėpI down_heap֐ɒuB
	             ɔāAq[v̍őeʂ܂ŗvfǉĂƂA
	             ppps_int_heap_remove_root֐ɂāA
	             ͈͊OANZX邱Ƃ̂CꂽB

	         1.0.0   '2013/2/3
*/

#include "ppps_int_heap.h"
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>


/* q[v */
struct PPPSIntHeap_tag {
	int*      data;        // f[^{
	size_t    capacity;    // őe
	size_t    first_empty; // ɂȂĂŏ̈ʒu
};

#define SWAP(type,a,b)          { type work = a; a = b; b = work; }

static void up_heap(PPPSIntHeap heap, size_t index);
static void down_heap(PPPSIntHeap heap, size_t root, size_t end);
static void heap_print_node(const PPPSIntHeap heap, size_t index, int level);


/* q[v */
PPPSIntHeap ppps_int_heap_create(size_t capacity)
{
	struct PPPSIntHeap_tag* heap = malloc( sizeof(struct PPPSIntHeap_tag) );
	heap->data = malloc( sizeof(int) * (capacity + 1) );  // Y 1 n߂邽߁A+ 1 Ċm
	heap->capacity = capacity;
	heap->first_empty = 1;  // 0Ԗڂ͎gȂ

	return heap;
}

/* q[v폜 */
void ppps_int_heap_delete(PPPSIntHeap heap)
{
	if( heap != NULL ){
		free( heap->data );
		free( heap );
	}
}

/* q[vɗvfǉ */
bool ppps_int_heap_insert(PPPSIntHeap heap, int value)
{
	// eʂtłȂmF
	if( heap->capacity < heap->first_empty ){
		return false;
	}


	// ܂Aɒǉ
	size_t index = heap->first_empty;
	heap->data[index] = value;
	heap->first_empty += 1;

	// K؂Ȉʒu܂ŕяオ点
	up_heap( heap, index );

	return true;
}

/* q[v獪菜 */
bool ppps_int_heap_remove_root(PPPSIntHeap heap, int* value)
{
	/* q[vłȂmF */
	if( ppps_int_heap_getsize(heap) <= 0 ){
		return false;
	}


	*value = heap->data[1];

	// q[v̍ŌɂvfA擪Ɉړ
	heap->first_empty -= 1;
	heap->data[1] = heap->data[heap->first_empty];
	
	// 擪ɈړvfAʒuɒ߂
	down_heap( heap, 1, heap->first_empty );
	
	return true;
}

/* q[vvfT */
bool ppps_int_heap_search(const PPPSIntHeap heap, int value)
{
	for( size_t i = 1; i < heap->first_empty; ++i ){
		if( heap->data[i] == value ){
			return true;
		}
	}

	return false;
}

/* q[vɊi[ĂvfԂ */
size_t ppps_int_heap_getsize(const PPPSIntHeap heap)
{
	return heap->first_empty - 1;
}

/* q[v̓eo͂ */
void ppps_int_heap_print(const PPPSIntHeap heap)
{
	if( heap == NULL || ppps_int_heap_getsize(heap) <= 0 ){
		return;
	}

	heap_print_node( heap, 1, 0 );
}

/* q[v̎wvfK؂Ȉʒu܂ŕяオ点 */
void up_heap(PPPSIntHeap heap, size_t index)
{
	while( index > 1 ){  // ɓBI
		size_t parent = index / 2;

		if( heap->data[parent] > heap->data[index] ){
			// eƂ̑召֌WtȂւ
			SWAP( int, heap->data[parent], heap->data[index] );
			
			// ɐeH
			index = parent;
		}
		else{
			// 召֌W킾I
			break;
		}
	}
}

/* q[v̎wvfK؂Ȉʒu܂Œ߂ */
void down_heap(PPPSIntHeap heap, size_t root, size_t end)
{
	while( root * 2 <= end ){
		size_t child = root * 2;  // ̎q̈ʒu

		// Q̎qȂAg
		// E̎q̓ÝA̎q̓Y + 1 ł
		if( child + 1 <= end ){
			if( heap->data[child] > heap->data[child + 1] ){
				child = child + 1;
			}
		}

		// qƂ̑召֌WtȂAւ
		if( heap->data[child] < heap->data[root] ){
			SWAP( int, heap->data[child], heap->data[root] );
			root = child;
		}
		else {
			break;
		}
	}
}

void heap_print_node(const PPPSIntHeap heap, size_t index, int level)
{
	for( size_t i = 1; i < level; ++i ){
		printf( "    " );
	}
	if( level > 0 ){
		printf( "+---" );
	}
	printf( "%d\n", heap->data[index] );


	// ̎q
	index *= 2;
	if( index < heap->first_empty ){
		heap_print_node( heap, index, level + 1 );
	}

	// E̎q
	index += 1;
	if( index < heap->first_empty ){
		heap_print_node( heap, index, level + 1 );
	}
}
