/*
	ppps_int_queue.c
	[TvCu] int^̃L[
	
	author:  K.Y (Programming Place Plus)
	
	version  1.0.2   '2019/9/23
	           EWebTCg C99Ki֑ΉƂɍ킹āAR[hCB
			     RgX^CƁAϐ錾ʒuςB
                 bool^gB
             
             1.0.1   '2013/1/26
	           Eppps_int_queue_try_dequeue֐ǉB
			   EO֌JȂ֐ static tB

	         1.0.0   '2012/7/7
*/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "ppps_int_queue.h"

static size_t get_next_index(PPPSIntQueue queue, size_t index);
static void* xmalloc(size_t size);


struct PPPSIntQueue_tag {
	int*    data;    // vfi[铮Iz
	size_t  size;    // data ̗vf
	size_t  front;   // 擪̗vf̈ʒu
	size_t  tail;    // ̗vf̈ʒu
};


/* L[ */
PPPSIntQueue ppps_int_queue_create(size_t size)
{
	// front == tail ̏Ԃɂ悤ƂƁAzŜg؂ԂȂB
	// ŁAw肳ꂽ size  +1 āAP]ɗ̈mۂĂB
	size += 1;

	struct PPPSIntQueue_tag* queue = xmalloc( sizeof(struct PPPSIntQueue_tag) );
	queue->data  = xmalloc( sizeof(int) * size );
	queue->size  = size;
	queue->front = 0;
	queue->tail  = 0;

	return queue;
}

/* L[폜 */
void ppps_int_queue_delete(PPPSIntQueue queue)
{
	free( queue->data );
	free( queue );
}

/* L[ɗvf */
void ppps_int_queue_enqueue(PPPSIntQueue queue, int value)
{
	assert( get_next_index(queue, queue->tail) != queue->front );

	queue->data[queue->tail] = value;

	// ɗvfƂɎgʒu߂
	// Oobt@\Ȃ̂ŁAP +1 邾ł̓_
	queue->tail = get_next_index( queue, queue->tail );
}

/* L[vfo */
int ppps_int_queue_dequeue(PPPSIntQueue queue)
{
	assert( !ppps_int_queue_is_empty(queue) );

	int pop_value = queue->data[queue->front];

	// 擪vfPôŁA擪ʒuXV
	// Oobt@\Ȃ̂ŁAP +1 邾ł̓_
	queue->front = get_next_index( queue, queue->front );

	return pop_value;
}

/* L[vfo (۔t) */
bool ppps_int_queue_try_dequeue(PPPSIntQueue queue, int* p)
{
	assert( p != NULL );

	if( ppps_int_queue_is_empty(queue) ){
		return false;
	}

	*p = queue->data[queue->front];

	// 擪vfPôŁA擪ʒuXV
	// Oobt@\Ȃ̂ŁAP +1 邾ł̓_
	queue->front = get_next_index( queue, queue->front );

	return true;
}

/* L[󂩂ǂׂ */
bool ppps_int_queue_is_empty(PPPSIntQueue queue)
{
	return queue->front == queue->tail;
}


/* P̓Y擾 */
size_t get_next_index(PPPSIntQueue queue, size_t index)
{
	return (index + 1) % queue->size;
}

/* G[`FbNt malloc֐ */
void* xmalloc(size_t size)
{
	void* p = malloc( size );
	if( p == NULL ){
		fputs( "蓖ĂɎs܂B", stderr );
		exit( EXIT_FAILURE );
	}
	return p;
}
